unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Menus, About, SetSize,
  Check, Name;

type
  TForm1 = class(TForm)
    Board: TPaintBox;
    Steuerung: TPanel;
    Statuszeile: TPanel;
    createBrick: TSpeedButton;
    CreateMaster: TSpeedButton;
    CreateFrame: TSpeedButton;
    CreateMagnet: TSpeedButton;
    CreateMagic: TSpeedButton;
    CreateKeyhole: TSpeedButton;
    CreateElim: TSpeedButton;
    CreateBlockade: TSpeedButton;
    CreateKey: TSpeedButton;
    CreateHole: TSpeedButton;
    CreateTarget: TSpeedButton;
    CreateTrap: TSpeedButton;
    createHSlide: TSpeedButton;
    CreateVSlide: TSpeedButton;
    CreateBarrier: TSpeedButton;
    IncGrid: TSpeedButton;
    DecGrid: TSpeedButton;
    AutoSize: TSpeedButton;
    DeleteBricks: TSpeedButton;
    DeleteArea: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MainMenu: TMainMenu;
    menFile: TMenuItem;
    menEdit: TMenuItem;
    NewBoard: TMenuItem;
    OpenBoard: TMenuItem;
    SaveBoard: TMenuItem;
    Saveas: TMenuItem;
    N1: TMenuItem;
    ExitEditor: TMenuItem;
    menHelp: TMenuItem;
    HelpTopics: TMenuItem;
    About: TMenuItem;
    N2: TMenuItem;
    clearFloor: TSpeedButton;
    PlayLevel: TSpeedButton;
    UndoEdit: TMenuItem;
    RedoEdit: TMenuItem;
    N3: TMenuItem;
    SelectAll: TMenuItem;
    CreateAnti: TSpeedButton;
    CreateWater: TSpeedButton;
    createMasterMagnet: TSpeedButton;
    Spiel: TPanel;
    StopGame: TSpeedButton;
    ResetBoard: TSpeedButton;
    NameOfLevel: TPanel;
    DeleteAreaTopic: TMenuItem;
    DeleteBricksTopic: TMenuItem;
    ClearFloorTopic: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    xxCut: TMenuItem;
    xxCopy: TMenuItem;
    xxPaste: TMenuItem;
    N7: TMenuItem;
    BrickTypes: TMenuItem;
    FloorFeatures: TMenuItem;
    NormalBrick1: TMenuItem;
    MasterBrick1: TMenuItem;
    Frame1: TMenuItem;
    N8: TMenuItem;
    Magnet1: TMenuItem;
    AntiMagnet1: TMenuItem;
    MasterMagnet1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Keyhole1: TMenuItem;
    N11: TMenuItem;
    BlockadeBrick1: TMenuItem;
    Barrier1: TMenuItem;
    MagicBrick1: TMenuItem;
    HorizontalSlider1: TMenuItem;
    VerticalSlider1: TMenuItem;
    N12: TMenuItem;
    Eliminator1: TMenuItem;
    WaterField1: TMenuItem;
    Hole1: TMenuItem;
    TargetDestination1: TMenuItem;
    Trap1: TMenuItem;
    LevelName: TPanel;
    menBoard: TMenuItem;
    SetBoardSize: TMenuItem;
    CheckBoard: TMenuItem;
    LevelName1: TMenuItem;
    N4: TMenuItem;
    IncreaseBoardSize1: TMenuItem;
    DecreaseBoardSize1: TMenuItem;
    AutomaticClipping1: TMenuItem;
    AliBabasFakeFrame1: TMenuItem;
    menuPlay: TMenuItem;
    PlayMode1: TMenuItem;
    ResetBoard1: TMenuItem;
    N13: TMenuItem;
    StepForward1: TMenuItem;
    StepBackward1: TMenuItem;
    MoveForward1: TMenuItem;
    MoveBackward1: TMenuItem;
    N14: TMenuItem;
    StoreBoard: TMenuItem;
    LoadBoardfromRAM1: TMenuItem;
    procedure RedrawBoard(Sender: TObject);
    procedure BricksInit(Sender: TObject);
    procedure DecGridClick(Sender: TObject);
    procedure IncGridClick(Sender: TObject);
    procedure SelectTile(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SelectArea(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RefreshClick(Sender: TObject);
    procedure CreateBrickClick(Sender: TObject);
    procedure CreateMasterClick(Sender: TObject);
    procedure createBorderClick(Sender: TObject);
    procedure DragArea(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure DeleteAreaClick(Sender: TObject);
    procedure DeleteBrickClick(Sender: TObject);
    procedure BoardClick(Sender: TObject);
    procedure CreateMagnetClick(Sender: TObject);
    procedure CreateMagicClick(Sender: TObject);
    procedure CreateKeyholeClick(Sender: TObject);
    procedure CreateElimClick(Sender: TObject);
    procedure CreateBlockadeClick(Sender: TObject);
    procedure CreateKeyClick(Sender: TObject);
    procedure CreateTargetClick(Sender: TObject);
    procedure CreateTrapClick(Sender: TObject);
    procedure CreateHoleClick(Sender: TObject);
    procedure createHSlideClick(Sender: TObject);
    procedure CreateVSlideClick(Sender: TObject);
    procedure CreateBarrierClick(Sender: TObject);
    procedure AutoSizeClick(Sender: TObject);
    procedure SaveasClick(Sender: TObject);
    procedure OpenBoardClick(Sender: TObject);
    procedure SaveBoardClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure HelpTopicsClick(Sender: TObject);
    procedure NewBoardClick(Sender: TObject);
    procedure ExitEditorClick(Sender: TObject);
    procedure CloseAndCheck(Sender: TObject; var Action: TCloseAction);
    procedure clearFloorClick(Sender: TObject);
    procedure PlayLevelClick(Sender: TObject);
    procedure ResetBoardClick(Sender: TObject);
    procedure UndoMoveClick(Sender: TObject);
    procedure SetBoardSizeClick(Sender: TObject);
    procedure SelectAllClick(Sender: TObject);
    procedure CheckBoardClick(Sender: TObject);
    procedure CreateAntiClick(Sender: TObject);
    procedure CreateWaterClick(Sender: TObject);
    procedure createMasterMagnetClick(Sender: TObject);
    procedure UndoEditClick(Sender: TObject);
    procedure RedoEditClick(Sender: TObject);
    procedure StopGameClick(Sender: TObject);
    procedure DeleteAreaTopicClick(Sender: TObject);
    procedure DeleteBricksTopicClick(Sender: TObject);
    procedure ClearFloorTopicClick(Sender: TObject);
    procedure NormalBrick1Click(Sender: TObject);
    procedure MasterBrick1Click(Sender: TObject);
    procedure Hole1Click(Sender: TObject);
    procedure TargetDestination1Click(Sender: TObject);
    procedure Trap1Click(Sender: TObject);
    procedure Frame1Click(Sender: TObject);
    procedure Barrier1Click(Sender: TObject);
    procedure LevelNameClick(Sender: TObject);
    procedure Magnet1Click(Sender: TObject);
    procedure AntiMagnet1Click(Sender: TObject);
    procedure MasterMagnet1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure Keyhole1Click(Sender: TObject);
    procedure BlockadeBrick1Click(Sender: TObject);
    procedure MagicBrick1Click(Sender: TObject);
    procedure HorizontalSlider1Click(Sender: TObject);
    procedure VerticalSlider1Click(Sender: TObject);
    procedure Eliminator1Click(Sender: TObject);
    procedure WaterField1Click(Sender: TObject);
    procedure LevelName1Click(Sender: TObject);
    procedure IncreaseBoardSize1Click(Sender: TObject);
    procedure DecreaseBoardSize1Click(Sender: TObject);
    procedure AutomaticClipping1Click(Sender: TObject);
    procedure AliBabasFakeFrame1Click(Sender: TObject);
    procedure xxCopyClick(Sender: TObject);
    procedure xxCutClick(Sender: TObject);
    procedure xxPasteClick(Sender: TObject);
    procedure PlayMode1Click(Sender: TObject);
    procedure StepBackward1Click(Sender: TObject);
    procedure StoreBoardClick(Sender: TObject);
    procedure LoadBoardfromRAM1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type
  TBoard = record
    nTiles: byte;
    bForm, bID: Array [0..24, 0..24] of Byte;
    bType: Array [0..255] of Byte;
  end;
  TBoardPtr = ^TBoard;
  TRecord = Array [0..1, 0..255] of Byte;
  TRecordPtr = ^TRecord;

const
  ProgTitle = 'Bricks Editor';
  NullTitle = '[No Title]';
  nUndo = 32;

  brkNormal = 99;
  brkMaster = 1;
  brkMagic = 2;
  brkMagnet = 3;
  brkElim = 4;
  brkHSlide = 5;
  brkVSlide = 6;
  brkKey = 7;
  brkBarrier = 8;
  brkBorder = 9;
  brkBlockade = 10;
  brkKeyhole = 11;
  brkMasterMagnet = 12;
  brkWater = 13;
  brkAnti = 14;
  brkFake = 15;

  flrTarget = 64;
  flrTrap = 128;
  flrHole = 192;

procedure MinMaxBoard (var left, top, right, bottom: Byte);
procedure UndoInfo;
procedure DrawTile (x, y: Byte);
procedure ResetSel;

var
  Fake: TShortCut;
  Form1: TForm1;
  be, bp, bClip, bRAM, bUndo: TBoard;
  bRamMove: Word;
  GridSize: Word;
  X0, Y0: Integer;
  Sel: Array [0..24, 0..24] of Byte;
  YY, XX, XE, YE: Byte;
  bs, bh, bd: Word;
  SelBricks: Set of Byte;
  Dirty, PlayMode: boolean;
  MoveInDir, MovedBrick, PrevBrick: byte;
  InitPos: TPoint;
  Moves: Word;
  bu: Array [1..nUndo] of TBoardPtr;
  MovePointer, MovesUndone, MovesSaved: Byte;
  MaxRec, CurRec: Word;
  MoveRec: TRecordPtr;

implementation

{$R *.DFM}

procedure xline (x1, y1, x2, y2: Integer);
begin
  Form1.Board.Canvas.MoveTo (x1, y1);
  Form1.Board.Canvas.LineTo (x2, y2);
end;

procedure xrect (x1, y1, x2, y2: Integer);
var
  DummyRect: TRect;
begin
  DummyRect.left := x1;
  DummyRect.top := y1;
  DummyRect.right := x2;
  DummyRect.bottom := y2;
  Form1.Board.Canvas.FillRect (DummyRect);
end;

procedure say (msg: String);
begin
  Form1.Statuszeile.Caption := msg;
end;

function TypeName (id: Byte): String;
begin
  case be.bType [id] of
    brkNormal:   TypeName := 'Normal Brick';
    brkMaster:   TypeName := 'Master Brick';
    brkBorder:   TypeName := 'Frame';
    brkMagnet:   TypeName := 'Magnet';
    brkElim:     TypeName := 'Eliminator';
    brkBlockade: TypeName := 'Blockade Brick';
    brkKey:      TypeName := 'Keystone';
    brkKeyhole:  TypeName := 'Keyhole';
    brkHSlide:   TypeName := 'Horizontal Slider';
    brkVSlide:   TypeName := 'Vertical Slider';
    brkBarrier:   TypeName := 'Barrier';
    brkWater:    TypeName := 'Water';
    brkAnti:     TypeName := 'Anti Magnet';
    brkMagic:    TypeName := 'Magic Brick';
    brkFake:     TypeName := 'Ali Baba''s Fake Frame';
    brkMasterMagnet:
                 TypeName := 'Master Magnet';
    else         TypeName := 'Unknown [' + IntToStr (be.bType [id])+ ']';
  end;
end;

procedure UndoInfo;
begin
  if not(Dirty) then
    Form1.Caption := Form1.Caption + ' *';
  dirty := true;
  Inc (MovePointer);
  if (MovePointer > nUndo) then
    MovePointer := 1;
  if (MovesSaved < nUndo-1) then
    Inc (MovesSaved);
  if (bu [MovePointer] = Nil) then
    New (bu [MovePointer]);
  bu [MovePointer]^ := be;
  MovesUndone := 0;
  Form1.UndoEdit.Enabled := True;
  Form1.RedoEdit.Enabled := False;
end;

procedure ClearDirty;
begin
  MovePointer := 1;
  if (bu [MovePointer] = Nil) then
    New (bu [MovePointer]);
  bu [MovePointer]^ := be;
  Form1.UndoEdit.Enabled := False;
  Form1.RedoEdit.Enabled := False;
  MovesSaved := 0;
  MovesUndone := 0;
  Dirty := False;
end;

function CheckDirty: Boolean;
  var mr: Word;
      Sender: TObject;
begin
  if (Dirty) then begin
    mr := MessageDlg ('The Board has been changed. Save it?',
      mtConfirmation, mbYesNoCancel, 0);
    if (mr = mrCancel) then
      CheckDirty := False
    else begin
      if (mr = mrYes) then begin
        Form1.SaveBoardClick (Sender);
        CheckDirty := (Form1.OpenDialog.Filename <> '');
      end;
    end;
  end else
    CheckDirty := True;
end;

procedure DrawTile (x, y: Byte);
  var  f, k, kk, bm: Integer;
       xx, yy: Integer;
       colBrick, colShade, colLine, colFloor: TColor;
       bb: TBoard;
begin
  if (PlayMode) then bb := bp else bb := be;

  if (x < bb.nTiles) and (y < bb.nTiles) then begin
  xx := x0 + x*GridSize;
  yy := y0 + y*GridSize;
  Form1.Board.Canvas.Brush.Style := bsSolid;
  if (sel [x, y] > 0) then
    Form1.Board.Canvas.Brush.Color := clBtnShadow
  else
    Form1.Board.Canvas.Brush.Color := clBtnFace;

  if not (PlayMode) then begin
    xRect (xx + 1, yy + 1, xx + GridSize, yy + GridSize);
    Form1.Board.Canvas.Pen.Color := clBtnShadow;
    xLine (xx, yy, xx, yy + GridSize);
    xLine (xx, yy, xx + GridSize, yy);
  end else
    xRect (xx, yy, xx + GridSize, yy + GridSize);

  if (bb.bID [x, y] <> 0) and (bb.bID [x, y] <> 4) then begin

    (* Farbe je nach Brick *)
    colLine := clYellow;
    colShade := clDkGray;
    if (sel [x, y] > 0) then begin
      colBrick := clWhite;
      colShade := clLtGray;
      colLine := clDkGray;
    end else begin
    case (bb.bType [bb.bID [x, y]]) of
      brkMaster, brkMasterMagnet:
        begin
          colBrick := $000000CC;
          colShade := $00000099;
        end;
      brkBorder, brkKeyhole, brkFake:
        begin
          colBrick := $00009900;
          colShade := $00006600;
          colLine := clLime;
        end;
      brkMagic, brkAnti:
        begin
          colBrick := clFuchsia;
          colShade := clPurple;
        end;
      brkElim, brkMagnet:
        begin
          colBrick := $00FFFF00;
          colShade := $00666600;
        end;
      brkBlockade:
        begin
          colBrick := $0099FFFF;
          colShade := $000066CC;
          colLine := $00003399;
        end;
      brkBarrier:
        begin
          colShade := $00990000;
          colLine := $00FFFF00;
          if (bb.bForm [x, y] and 192 = 0) then begin
            colBrick := $00FF0000;
          end else
            colBrick := $00FF9900;
          end;
      else
        begin
          colBrick := $000066CC;
          colShade := $00003399;
        end;
    end;
    end;
    Form1.Board.Canvas.Brush.Style := bsSolid;
    Form1.Board.Canvas.Brush.Color := colBrick;
    Form1.Board.Canvas.Pen.Color := colLine;
    if (sel [x, y] > 0) then
      Form1.Board.Canvas.Brush.Style := bsBDiagonal;

    (* Regelmiger Block *)
    if (bb.bForm [x, y] and 63 < 16) then begin
      f := bb.bForm [x, y] and 15;

      case f of
        6, 7, 14, 15: begin
              xRect (xx, yy, xx + GridSize, yy + GridSize);
              if (f and 1 = 0) then
                xLine (xx, yy, xx + GridSize, yy);
              if (f and 8 = 0) then
                xLine (xx, yy, xx, yy + GridSize);
            end;
        12, 13: begin
              xRect (xx, yy, xx + bs, yy + GridSize);
              xLine (xx + bs, yy, xx + bs, yy + GridSize);
              if (f = 12) then
                xLine (xx, yy, xx + bs, yy);
            end;
        3, 11: begin
              xRect (xx, yy, xx + GridSize, yy + bs);
              xLine (xx, yy + bs, xx + GridSize, yy + bs);
              if (f = 3) then
                xLine (xx, yy, xx, yy + bs);
            end;
        else begin
          Inc (bp.bForm [x, y], 16);
          Inc (be.bForm [x, y], 16);
          DrawTile (x, y);
          Dec (bp.bForm [x, y], 16);
          Dec (be.bForm [x, y], 16);
        end;
      end;

      (* Schatten *)
      Form1.Board.Canvas.Brush.Style := bsSolid;
      Form1.Board.Canvas.Brush.Color := colShade;
      Form1.Board.Canvas.Pen.Style := psClear;
      case f of
        12: Form1.Board.Canvas.Polygon
                ([Point (xx + bs + 1, yy + 1),
                  Point (xx + bs + bh, yy + bh),
                  Point (xx + bs + bh, yy + GridSize),
                  Point (xx + bs + 1, yy + GridSize)]);
        13: xrect (xx + bs + 1, yy, xx + bs + bh, yy + GridSize);
        3:  Form1.Board.Canvas.Polygon
              ([Point (xx + 1, yy + bs + 1),
                Point (xx + bh, yy + bs + bh),
                Point (xx + GridSize, yy + bs + bh),
                Point (xx + GridSize, yy + bs + 1)]);
        11: xrect (xx, yy + bs + 1, xx + GridSize, yy + bs + bh);
      end;
      Form1.Board.Canvas.Pen.Style := psSolid;
    end;

    (* Beliebige Form *)
    if (bb.bForm [x, y] and 63 in [16..31]) then begin
      f := bb.bForm [x, y] and 15;

      (* Block*)
      xRect (xx, yy, xx + bs + 1, yy + bs + 1);
      if (f and 2 > 0) then
        xRect (xx + bs, yy, xx + GridSize, yy + bs + 1);
      if (f and 4 > 0) then
        xRect (xx, yy + bs, xx + bs + 1, yy + GridSize);

      (* Rahmen *)
      if (f and 1 = 0) then
        xLine (xx, yy, xx + bs, yy);
      if (f and 2 = 0) then
        xLine (xx + bs, yy, xx + bs, yy + bs + 1)
      else begin
        xLine (xx + bs, yy, xx + GridSize, yy);
        xLine (xx + bs, yy + bs, xx + GridSize, yy + bs);
      end;
      if (f and 4 = 0) then
        xLine (xx, yy + bs, xx + bs + 1, yy + bs)
      else begin
        xLine (xx + bs, yy + bs, xx + bs, yy + GridSize);
        xLine (xx, yy + bs, xx, yy + GridSize);
      end;
      if (f and 8 = 0) then
        xLine (xx, yy, xx, yy + bs);
      xLine (xx, yy, xx, yy);

      (* Schatten *)
      Form1.Board.Canvas.Brush.Style := bsSolid;
      Form1.Board.Canvas.Brush.Color := colShade;
      Form1.Board.Canvas.Pen.Style := psClear;
      if (f and 2 = 0) then begin
        if (f and 1 = 0) then
          Form1.Board.Canvas.Polygon
          ([Point (xx + bs + 1, yy + 1),
            Point (xx + bs + bh, yy + bh),
            Point (xx + bs + bh, yy + bs + 1),
            Point (xx + bs + 1, yy + bs + 1)])
        else
          xrect (xx + bs + 1, yy, xx + bs + bh, yy + bs + 1);
      end;
      if (f and 4 = 0) then begin
        if (f and 8 = 0) then
          Form1.Board.Canvas.Polygon
          ([Point (xx + 1, yy + bs + 1),
            Point (xx + bh, yy + bs + bh),
            Point (xx + bs+ 1, yy + bs + bh),
            Point (xx + bs + 1, yy + bs + 1)])
        else
          xrect (xx, yy + bs + 1, xx + bs + 1, yy + bs + bh);
      end;
      case (f and 6) of
        2:   xRect (xx + bs + 1, yy + bs + 1, xx  + GridSize, yy + bs + bh);
        4:   xRect (xx + bs + 1, yy + bs + 1, xx + bs + bh, yy + GridSize);
        6:   Form1.Board.Canvas.Polygon
             ([Point (xx + bs + 1, yy + bs + 1),
             Point (xx + GridSize, yy + bs + 1),
             Point (xx + GridSize, yy + bs + bh),
             Point (xx + bs + bh, yy + bs + bh),
             Point (xx + bs + bh, yy + GridSize),
             Point (xx + bs + 1, yy + GridSize)])
        else xRect (xx + bs + 1, yy + bs + 1, xx + bs + bh, yy + bs + bh);
      end;
      Form1.Board.Canvas.Pen.Style := psSolid;
    end;

      (* Magneten *)
      if (bb.bType [bb.bID [x, y]] in [brkMagnet, brkMasterMagnet, brkAnti]) then begin
        case bb.bType [bb.bID [x, y]] of
          brkMagnet: Form1.Board.Canvas.Brush.Color := $00666600;
          brkMasterMagnet:
                     Form1.Board.Canvas.Brush.Color := $00000066;
          brkAnti:   Form1.Board.Canvas.Brush.Color := $00990099;
        end;
        xRect (xx + 1, yy + 1, xx + bs div 2, yy + bs div 2);
        xRect (xx + bs div 2 + 1, yy + bs div 2 + 1, xx + bs, yy + bs);
      end;

      (* Ahnk *)
      if (bb.bType [bb.bID [x, y]] in [brkKey, brkKeyhole]) then begin
        k := Round (0.4 * bs);
        kk := Round (0.3 * bs);
        bm := bs div 2;
        Form1.Board.Canvas.Pen.Color := clBlack;
        Form1.Board.Canvas.Pen.Width := bs div 32 + 1;
        xLine (xx + bm, yy + bm, xx + bm, yy + bm + k);
        xLine (xx + bm - kk, yy + bm, xx + bm + kk, yy + bm);
        xLine (xx + bm, yy + bm, xx + bm - k div 2, yy + bm - k);
        xLine (xx + bm, yy + bm, xx + bm + k div 2, yy + bm - k);
        xLine (xx + bm - k div 2, yy + bm - k, xx + bm + k div 2, yy + bm - k);
        xLine (xx + bm - kk div 2, yy + bm + k, xx + bm + kk div 2, yy + bm + k);
        xLine (xx + bm + kk, yy + bm - kk div 2, xx + bm + kk, yy + bm + k div 2);
        xLine (xx + bm - kk, yy + bm - kk div 2, xx + bm - kk, yy + bm + k div 2);
        Form1.Board.Canvas.Pen.Width := 1;
      end;

      (* horizontaler Slider *)
      if (bb.bType [bb.bID [x, y]] = brkHSlide) then begin
        k := Round (bs*0.3);
        Form1.Board.Canvas.Brush.Color := $0000FFFF;

        case (bb.bForm [x, y] and 10) of
          2:   xRect (xx + k, yy + k, xx + GridSize, yy + bs - k);
          8:   xRect (xx, yy + k, xx + bs - k, yy + bs - k);
          10:  xRect (xx, yy + k, xx + GridSize, yy + bs - k);
          else xRect (xx + k, yy + k, xx + bs - k, yy + bs - k);
        end;
      end;

      (* vertikaler Slider *)
      if (bb.bType [bb.bID [x, y]] = brkVSlide) then begin
        k := Round (bs*0.3);
        Form1.Board.Canvas.Brush.Color := $0000FFFF;

        case (bb.bForm [x, y] and 5) of
          1:   xRect (xx + k, yy, xx + bs - k, yy + bs - k);
          4:   xRect (xx + k, yy + k, xx + bs - k, yy + GridSize);
          5:  xRect (xx + k, yy, xx + bs - k, yy + GridSize);
          else xRect (xx + k, yy + k, xx + bs - k, yy + bs - k);
        end;
      end;

  end;

  (* Bodenelemente *)
  if (bb.bForm [x, y] and 192 > 0) and
  ((bb.bID [x, y] > 7) or (bb.bID [x, y] = 0)) and
  (bb.bType [bb.bID [x, y]] <> brkBarrier) then begin
    case (bb.bForm [x, y] and 192) of
      64:  colFloor := $000000FF;
      128: colFloor := $00009900;
      else colFloor := clBlack;
    end;
    if (sel [x, y] > 0) then colFloor := clWhite;

    Form1.Board.Canvas.Brush.Color := colFloor;
    if (bb.bID [x, y] = 0) then
      k := 1
    else
      k := Round (bs*0.3);
    xRect (xx + k + 1, yy + k + 1, xx+bs - k, yy+bs - k)
  end;

  (* Wasser *)
  if (bb.bID [x, y] = 4) then begin
    if (sel [x, y] > 0) then
      Form1.Board.Canvas.Brush.Color := clWhite
    else
      Form1.Board.Canvas.Brush.Color := $00FFFF00;
    k := 1;
    xRect (xx + k + 1, yy + k + 1, xx+bs - k, yy+bs - k)
  end;
end;
end;

procedure TForm1.RedrawBoard(Sender: TObject);
  var i, j, dx, dy: Integer;
      bb: TBoard;
begin
  if (PlayMode) then bb := bp else bb := be;
  if (bb.nTiles = 0) then
    ShowMessage ('Division durch Null!');
  try
    dx := (Form1.Board.Width - 2) div bb.nTiles;
    dy := (Form1.Board.Height - 2) div bb.nTiles;
  except
    on EDivByZero do begin
      MessageDlg ('Division by Zero', mtError, [mbOk], 0);
      dx := 12;
      dy := 12;
    end;
    else ShowMessage ('Something''s wrong!');
  end;
  if (dx < dy) then
    GridSize := dx
  else
    GridSize := dy;
  X0 := (Form1.Board.Width - bb.nTiles*GridSize) div 2;
  Y0 := (Form1.Board.Height - bb.nTiles*GridSize) div 2;

  bs := round (0.8 * GridSize);
  bd := round (0.05 * GridSize);
  bh := GridSize - bd - bs;

  Form1.Board.Canvas.Brush.Style := bsSolid;
  Form1.Board.Canvas.Brush.Color := clBtnFace;
  Form1.Board.Canvas.FillRect
    (Rect (0, 0, Form1.Board.Width, Form1.Board.Height));

  with Form1.Board.Canvas.Pen do begin
    Color := clBtnShadow;
    Style := psSolid;
    Width := 1;
  end;

  if not (PlayMode) then
    For i := 0 to be.nTiles do with Form1.Board.Canvas do begin
      MoveTo (X0 + i*GridSize, Y0);
      LineTo (X0 + i*GridSize, Y0 + be.nTiles*GridSize);
      MoveTo (X0, Y0 + i*GridSize);
      LineTo (X0 + be.nTiles*GridSize, Y0 + i*GridSize);
    end;

  For i := 0 to 24 do
    For j := 0 to 24 do begin
      sel [i, j] := 0;
      if (i < be.nTiles) and (j < be.nTiles) then drawTile (i, j);
    end;
  XX := 99;
end;

procedure TForm1.BricksInit(Sender: TObject);
  var i, j: Byte;
begin
  Opendialog.Filename := '';
  Form1.Caption := ProgTitle + ': [untitled]';
  Form1.LevelName.Caption := NullTitle;

  Fake := ShortCut ($6B, []);
  IncreaseBoardSize1.ShortCut := Fake;
  Fake := ShortCut ($6D, []);
  DecreaseBoardSize1.ShortCut := Fake;

  For i := 0 to 24 do
    For j := 0 to 24 do begin
      be.bForm [i, j] := 0;
      be.bID [i, j] := 0;
    end;

  For i := 0 to 255 do
    be.bType [i] := 0;
  be.bType [1] := brkBorder;

  ClearDirty;
  if (PlayMode) then PlayLevelClick (Sender);
  PlayMode := False;
  bp := be;
  be.nTiles := 12;
  Form1.RedrawBoard (Sender);
end;

procedure MinMaxBoard (var left, top, right, bottom: Byte);
  var i, j: Byte;
begin
  top := 99;
  left := 99;
  right := 0;
  bottom := 0;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (be.bForm [i, j] > 0) or (be.bID [i, j] > 0) then begin
        if (j < top) then top := j;
        if (j > bottom) then bottom := j;
        if (i < left) then left := i;
        if (i > right) then right := i;
      end;
end;

procedure TForm1.DecGridClick(Sender: TObject);
  var ix, iy, xx, yy: byte;
begin
  MinMaxBoard (ix, iy, xx, yy);
  if (be.nTiles > 1) and (be.nTiles > xx+1) and (be.nTiles > yy+1) then begin
    Dec (be.nTiles);
    Form1.RedrawBoard (Sender);
    UndoInfo;
    Say (IntToStr (be.nTiles) + 'x' + IntToStr (be.nTiles) + ' Board');
  end;
end;

procedure TForm1.IncGridClick(Sender: TObject);
begin
  if (be.nTiles < 25) then begin
    Inc (be.nTiles);
    Form1.RedrawBoard (Sender);
    UndoInfo;
    Say (IntToStr (be.nTiles) + 'x' + IntToStr (be.nTiles) + ' Board');
  end;
end;

procedure TForm1.AutoSizeClick(Sender: TObject);
  var ix, iy, xx, yy, i ,j, n: byte;
begin
  n := be.nTiles;
  MinMaxBoard (ix, iy, xx, yy);
  if (ix + iy > 0) and (ix <> 99) then
    For i := 0 to be.nTiles - ix - 1 do
      For j := 0 to be.nTiles - iy - 1 do begin
        be.bID [i, j] := be.bID [i + ix, j + iy];
        be.bForm [i, j] := be.bForm [i + ix, j + iy];
        be.bID [i + ix, j + iy] := 0;
        be.bForm [i + ix, j + iy] := 0;
      end;
  if (ix <> 99) then
    if (xx - ix > yy - iy) then
      be.nTiles := xx - ix + 1
    else
      be.nTiles := yy - iy + 1;
  if (be.nTiles <> n) then begin
    Form1.RedrawBoard (Sender);
    UndoInfo;
    Say ('Board resized to ' + IntToStr (be.nTiles) + 'x'
         + IntToStr (be.nTiles) + '.');
  end;
end;

procedure Swap (var a, b: Byte);
  var c: Byte;
begin
  c := a;
  a := b;
  b := c;
end;

procedure DrawFocus (xx, yy, xe, ye: Byte);
  var DummyRect: TRect;
begin
  if (xx > xe) then Swap (xx, xe);
  if (yy > ye) then Swap (yy, ye);
  Form1.Board.Canvas.DrawFocusRect
    (Rect (X0 + xx*GridSize, Y0 + yy*GridSize,
    X0 + (xe+1)*GridSize, Y0 + (ye+1)*GridSize));
end;

procedure ResetSel;
  var i, j: Byte;
begin
  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        sel [i, j] := 0;
        DrawTile (i, j);
      end;
end;

procedure CheckAnti (i, j, m, k: byte);
begin
  if (i >= 0) and (i < bp.nTiles) and (j >= 0) and (j < bp.nTiles) and
  (bp.bType [bp.bID [i, j]] = m) then
    MoveInDir := MoveInDir and (15 - k);
end;

procedure CheckDirections (n: Byte);
  var i, j, m: byte;
      area: PRect;
begin
  if (xx < 100) then begin
  case bp.bType [n] of
    brkVSlide:  MoveInDir := 5;
    brkHSlide:  MoveInDir := 10;
    brkBarrier, brkBlockade:
                MoveInDir := 0;
    else        MoveInDir := 15;
  end;

  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      if (bp.bID [i, j] = n) then begin
        if (MoveInDir and 1 > 0) and
        ((j = 0) or not(bp.bID [i, j-1] in [0, n])) then
          Dec (MoveInDir, 1);

        if (MoveInDir and 2 > 0) and
        ((i = bp.nTiles-1) or not(bp.bID [i+1, j] in [0, n])) then
          Dec (MoveInDir, 2);

        if (MoveInDir and 4 > 0) and
        ((j = bp.nTiles-1) or not(bp.bID [i, j+1] in [0, n])) then
          Dec (MoveInDir, 4);

        if (MoveInDir and 8 > 0) and
        ((i = 0) or not(bp.bID [i-1, j] in [0, n])) then
          Dec (MoveInDir, 8);

        if (bp.bType [n] in [brkMagnet, brkAnti]) then begin
          if (bp.bType [n] = brkMagnet) then
            m := brkAnti
          else
            m := brkMagnet;
            CheckAnti (i, j-2, m, 1);
            CheckAnti (i+1, j-1, m, 3);
            CheckAnti (i+2, j, m, 2);
            CheckAnti (i+1, j+1, m, 6);
            CheckAnti (i, j+2, m, 4);
            CheckAnti (i-1, j+1, m, 12);
            CheckAnti (i-2, j, m, 8);
            CheckAnti (i-1, j-1, m, 9);
        end;
      end;
  New (Area);
  Area^ := Rect (InitPos.x, InitPos.y, InitPos.x+1, InitPos.y+1);
  if (MoveInDir and 1 > 0) then Dec (Area^.Top, GridSize);
  if (MoveInDir and 2 > 0) then Inc (Area^.Right, GridSize);
  if (MoveInDir and 4 > 0) then Inc (Area^.Bottom, GridSize);
  if (MoveInDir and 8 > 0) then Dec (Area^.Left, GridSize);
  ClipCursor (Area);
  end;
end;

procedure KillBrick (n: byte);
  var i, j: byte;
begin
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (bp.bID [i, j] = n) then begin
        bp.bID [i, j] := 0;
        if (bp.bType [n] = brkBarrier) then
          bp.bForm [i, j] := 0
        else
          bp.bForm [i, j] := bp.bForm [i, j] and 192;
        if (bp.bForm [i, j] = 128) then begin
          bp.bForm [i, j] := 16;
          bp.bID [i, j] := 1;
        end;
        drawTile (i,j);
      end;
end;

procedure OpenBarrier (n: Byte);
  var Unlocked: Boolean;
      i, j: Byte;
begin
  Unlocked := true;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (bp.bID [i, j] = n) and (bp.bForm [i, j] and 192 = 0) then
        Unlocked := False;
  if (Unlocked) then begin
    KillBrick (n);
    PrevBrick := 0;
  end;
end;

procedure TForm1.SelectTile(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var i, j, k: Byte;
begin
  if (PlayMode) then begin
    if (X >= X0) and (X <= X0 + be.nTiles*GridSize) and
      (Y >= Y0) and (Y <= Y0 + be.nTiles*GridSize) and
      (xx = 99) and (Button = mbLeft) then begin
      xx := (X - X0) div GridSize;
      yy := (Y - Y0) div GridSize;
      MovedBrick := bp.bID [xx, yy];
      GetCursorPos (InitPos);
      if (bp.bType [MovedBrick] = brkBarrier) then begin
        OpenBarrier (MovedBrick);
        xx := 99;
      end else if (MovedBrick > 7) then
        CheckDirections (MovedBrick)
      else MoveInDir := 0;
    end;

  end else begin
    (* Beginn der Markierung *)
    if (X >= X0) and (X <= X0 + be.nTiles*GridSize) and
      (Y >= Y0) and (Y <= Y0 + be.nTiles*GridSize) and
      (xx = 99) and (Button = mbLeft) then begin
      xx := (X - X0) div GridSize;
      yy := (Y - Y0) div GridSize;
      xe := xx;
      ye := yy;
      DrawFocus (xx, yy, xx, yy);
    end;

    (* Selektion lschen *)
    if (Button = mbRight) then begin
      ResetSel;
    end;

    (* Doppelklick *)
    if (ssDouble in Shift) then begin
      xx := (X - X0) div GridSize;
      yy := (Y - Y0) div GridSize;
      DrawFocus (xx, yy, xx, yy);
      k := be.bID [xx, yy];
      say ('Brick #' + IntToStr (k) + ': ' + TypeName (k));
      if (k = 0) then k := 255;
      For i := 0 to be.nTiles - 1 do
        For j := 0 to be.nTiles - 1 do
          if (be.bID [i, j] = k) and (sel [i, j] = 0) then begin
            sel [i, j] := 1;
            DrawTile (i, j);
          end;
      XX := 99;
    end;

    Form1.ActiveControl := Statuszeile;
  end;
end;

procedure Eliminate (i, j: byte; var e: Boolean);
begin
  if (bp.bID [i, j] > 0) and (bp.bType [bp.bID [i, j]] = brkElim) and
  (bp.bID [i, j] <> MovedBrick) then begin
    e := True;
    KillBrick (bp.bID [i, j]);
  end else
    if (bp.bID [i, j] = 4) then begin
      e := True;
      bp.bID [i, j] := 0;
      DrawTile (i, j);
    end else
      e := e;
end;

procedure StickTogether (i, j, brkType: byte; var FallInHole: Boolean);
  var ii, jj, k: Byte;
begin
  if (bp.bID [i, j] > 0) and (bp.bType [bp.bID [i, j]] = brkType) and
  (bp.bID [i, j] <> MovedBrick) then begin
    k := bp.bID [i, j];
    bp.bType [k] := 0;
    FallInHole := False;
    for ii:= 0 to bp.nTiles - 1 do
      for jj:= 0 to bp.nTiles - 1 do
        if (bp.bID [ii, jj] = k) then
          bp.bID [ii, jj] := MovedBrick;
  end;
end;

procedure StickMaster (i, j, brkType: byte; var FallInHole: Boolean);
  var ii, jj, k: Byte;
begin
  if (bp.bID [i, j] > 0) and (bp.bType [bp.bID [i, j]] = brkType) and
  (bp.bID [i, j] <> MovedBrick) then begin
    k := bp.bID [i, j];
    bp.bType [MovedBrick] := brkMasterMagnet;
    bp.bType [k] := 0;
    FallInHole := False;
    for ii:= 0 to bp.nTiles - 1 do
      for jj:= 0 to bp.nTiles - 1 do
        if (bp.bID [ii, jj] in [k, MovedBrick]) then begin
          bp.bID [ii, jj] := MovedBrick;
          DrawTile (ii, jj);
        end;
  end;
end;

procedure UnlockBarrier (i, j: byte);
begin
  if (bp.bID [i, j] > 0) and
  (bp.bType [bp.bID [i, j]] = brkBarrier) then begin
    bp.bForm [i, j] := bp.bForm [i, j] and 63 + 192;
    drawTile (i, j);
  end;
end;

procedure UnlockBlockade;
  var i, j: byte;
      Changed: Set of Byte;
begin
  Changed := [];
  For i := 8 to 255 do
    if (bp.bType [i] = brkBlockade) then begin
      bp.bType [i] := brkNormal;
      Changed := Changed + [i];
    end;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (bp.bID [i, j] in Changed) then
        DrawTile (i, j);
end;

procedure RecordMove (x: byte);
begin
  if (MaxRec = SizeOf (MoveRec^) - 1) then begin
    ClipCursor (Nil);
    MessageDlg ('Too many steps -- recording stopped.', mtWarning, [mbOK], 0);
    XX := 99;
    Inc (MaxRec);
  end else if (MaxRec < SizeOf (MoveRec^) - 1) then begin
    if (MaxRec > CurRec) then MaxRec := CurRec;
    Inc (MaxRec);
    Inc (CurRec);
    MoveRec^ [MaxRec div 256, MaxRec mod 256] := x;
  end;
end;

procedure AfterMove (n: byte);
  var i, j, k: byte;
      FallInHole, Eliminated, Finished: Boolean;
begin
  FallInHole := True;
  Eliminated := False;
  Finished := (bp.bType [n] = brkMaster) or (bp.bType [n] = brkMasterMagnet);
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do begin
      if (bp.bID [i, j] = n) then begin
        if (bp.bForm [i, j] and 192 <> 192) then FallInHole := False;
        if (bp.bType [n] = brkElim) then begin
          Eliminate (i, j-1, Eliminated);
          Eliminate (i+1, j, Eliminated);
          Eliminate (i, j+1, Eliminated);
          Eliminate (i-1, j, Eliminated);
        end;
        if (bp.bType [n] = brkKey) and
        ((bp.bID [i, j-1] = 3) or (bp.bID [i+1, j] = 3) or
        (bp.bID [i, j+1] = 3) or (bp.bID [i-1, j] = 3)) then begin
          UnlockBlockade;
          Eliminated := true;
        end;
        if (bp.bType [n] in [brkMagnet, brkAnti, brkMasterMagnet]) then begin
          StickTogether (i, j-1, bp.bType [n], FallInHole);
          StickTogether (i+1, j, bp.bType [n], FallInHole);
          StickTogether (i, j+1, bp.bType [n], FallInHole);
          StickTogether (i-1, j, bp.bType [n], FallInHole);
        end;
        if (bp.bType [n] in [brkMagnet, brkMasterMagnet]) then begin
          if (bp.bType [n] = brkMagnet) then
            k := brkMasterMagnet else k := brkMagnet;
          StickMaster (i, j-1, k, FallInHole);
          StickMaster (i+1, j, k, FallInHole);
          StickMaster (i, j+1, k, FallInHole);
          StickMaster (i-1, j, k, FallInHole);
        end;
        if (bp.bType [n] in [brkMaster, brkMasterMagnet]) then begin
          if (bp.bForm [i, j] and 192 <> 64) then
            Finished := False;
          UnlockBarrier (i, j-1);
          UnlockBarrier (i+1, j);
          UnlockBarrier (i, j+1);
          UnlockBarrier (i-1, j);
        end;
      end else begin
        if (bp.bType [n] in [brkMaster, brkMasterMagnet]) and
        (bp.bForm [i, j] and 192 = 64) then
          Finished := False;
      end;
    end;
  if (FallInHole or Eliminated) then begin
    KillBrick (n);
    ClipCursor (Nil);
    xx := 99;
  end;
  if (PrevBrick <> MovedBrick) then begin
    PrevBrick := MovedBrick;
    Inc (Moves);
    Say (IntToStr (Moves) + ' moves');
    RecordMove (MovedBrick);
  end;
  if (Finished) then begin
    ClipCursor (Nil);
    xx := 101;
    ShowMessage ('You have completed this level in '
      + IntToStr (Moves) + ' moves!');
  end;
end;

procedure NewCursorPos (n: byte);
  var OldPos: TPoint;
begin
  OldPos := InitPos;
  GetCursorPos (InitPos);
  if (n = 0) then
    InitPos.y := OldPos.y
  else
    InitPos.x := OldPos.x;
end;

procedure MoveNorth (n: byte);
  var i, j: byte;
begin
  bUndo := bp;
  For i := 0 to bp.nTiles - 1 do
    For j := 0 to bp.nTiles - 2 do
      if (bp.bID [i, j+1] = n) then begin
        bp.bID [i, j] := bp.bID [i, j+1];
        bp.bForm [i, j] := bp.bForm [i, j] and 192
                        + bp.bForm [i, j+1] and 63;
        bp.bID [i, j+1] := 0;
        bp.bForm [i, j+1] := bp.bForm [i, j+1] and 192;
        if (bp.bForm [i, j+1] = 128) and
        ((j = bp.nTiles - 2) or (bp.bID [i, j+2] <> n)) then begin
          bp.bID [i, j+1] := 1;
          bp.bForm [i, j+1] := 16;
        end;
      end;
  For i := 0 to bp.nTiles - 1 do
    For j := 0 to bp.nTiles - 1 do
      if (bp.bID [i, j-1] = n) or (bp.bID [i, j] = n) then
        drawTile (i, j);
  xx := xe;
  yy := ye;
  AfterMove (MovedBrick);
  RecordMove (1);
  NewCursorPos (1);
  CheckDirections (MovedBrick);
end;

procedure MoveEast (n: byte);
  var i, j: byte;
begin
  bUndo := bp;
  For i := bp.nTiles downto 1 do
    For j := bp.nTiles downto 0 do
      if (bp.bID [i-1, j] = n) then begin
        bp.bID [i, j] := bp.bID [i-1, j];
        bp.bForm [i, j] := bp.bForm [i, j] and 192
                        + bp.bForm [i-1, j] and 63;
        bp.bID [i-1, j] := 0;
        bp.bForm [i-1, j] := bp.bForm [i-1, j] and 192;
        if (bp.bForm [i-1, j] = 128) and
        ((j = 1) or (bp.bID [i-2, j] <> n)) then begin
          bp.bID [i-1, j] := 1;
          bp.bForm [i-1, j] := 16;
        end;
      end;
  For i := 0 to bp.nTiles - 1 do
    For j := 0 to bp.nTiles - 1 do
      if (bp.bID [i+1, j] = n) or (bp.bID [i, j] = n) then
        drawTile (i, j);
  xx := xe;
  yy := ye;
  AfterMove (MovedBrick);
  RecordMove (2);
  NewCursorPos (0);
  CheckDirections (MovedBrick);
end;

procedure MoveSouth (n: byte);
  var i, j: byte;
begin         
  bUndo := bp;
  For i := bp.nTiles - 1 downto 0 do
    For j := bp.nTiles - 1 downto 1 do
      if (bp.bID [i, j-1] = n) then begin
        bp.bID [i, j] := bp.bID [i, j-1];
        bp.bForm [i, j] := bp.bForm [i, j] and 192
                        + bp.bForm [i, j-1] and 63;
        bp.bID [i, j-1] := 0;
        bp.bForm [i, j-1] := bp.bForm [i, j-1] and 192;
        if (bp.bForm [i, j-1] = 128) and
        ((j = 1) or (bp.bID [i, j-2] <> n)) then begin
          bp.bID [i, j-1] := 1;
          bp.bForm [i, j-1] := 16;
        end;
      end;
  For i := 0 to bp.nTiles - 1 do
    For j := 0 to bp.nTiles - 1 do
      if (bp.bID [i, j+1] = n) or (bp.bID [i, j] = n) then
        drawTile (i, j);
  xx := xe;
  yy := ye;
  AfterMove (MovedBrick);
  RecordMove (3);
  NewCursorPos (1);
  CheckDirections (MovedBrick);
end;

procedure MoveWest (n: byte);
  var i, j: byte;
begin         
  bUndo := bp;
  For i := 0 to bp.nTiles - 2 do
    For j := 0 to bp.nTiles - 1 do
      if (bp.bID [i+1, j] = n) then begin
        bp.bID [i, j] := bp.bID [i+1, j];
        bp.bForm [i, j] := bp.bForm [i, j] and 192
                        + bp.bForm [i+1, j] and 63;
        bp.bID [i+1, j] := 0;
        bp.bForm [i+1, j] := bp.bForm [i+1, j] and 192;
        if (bp.bForm [i+1, j] = 128) and
        ((j = bp.nTiles - 2) or (bp.bID [i+2, j] <> n)) then begin
          bp.bID [i+1, j] := 1;
          bp.bForm [i+1, j] := 16;
        end;
      end;
  For i := 0 to bp.nTiles - 1 do
    For j := 0 to bp.nTiles - 1 do
      if (bp.bID [i-1, j] = n) or (bp.bID [i, j] = n) then
        drawTile (i, j);
  xx := xe;
  yy := ye;
  AfterMove (MovedBrick);
  RecordMove (4);
  NewCursorPos (0);
  CheckDirections (MovedBrick);
end;

procedure TForm1.DragArea(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var xz, yz: byte;
      ActPos: TPoint;
begin
  if (PlayMode) then begin
    if (xx < 99) then begin
      xe := (X - X0) div GridSize;
      ye := (Y - Y0) div GridSize;
      GetCursorPos (ActPos);
      if (ActPos.y <= InitPos.y - GridSize) and (MoveInDir and 1 > 0) then
        MoveNorth (MovedBrick);
      if (ActPos.x >= InitPos.x + GridSize) and (MoveInDir and 2 > 0) then
        MoveEast (MovedBrick);
      if (ActPos.y >= InitPos.y + GridSize) and (MoveInDir and 4 > 0) then
        MoveSouth (MovedBrick);
      if (ActPos.x <= InitPos.x - GridSize) and (MoveInDir and 8 > 0) then
        MoveWest (MovedBrick);
      (*
      if (ye <= yy - 1) and (MoveInDir and 1 > 0) then
        MoveNorth (MovedBrick);
      if (xe >= xx + 1) and (MoveInDir and 2 > 0) then
        MoveEast (MovedBrick);
      if (ye >= yy + 1) and (MoveInDir and 4 > 0) then
        MoveSouth (MovedBrick);
      if (xe <= xx - 1) and (MoveInDir and 8 > 0) then
        MoveWest (MovedBrick);
      *)
    end;
  end else begin
    if (xx <> 99) then begin
      xz := xe;
      yz := ye;
      xe := (X - X0) div GridSize;
      ye := (Y - Y0) div GridSize;
      if (xz <> xe) or (yz <> ye) then begin
        DrawFocus (xx, yy, xz, yz);
        DrawFocus (xx, yy, xe, ye);
      end;
    end else begin
      xe := (X - X0) div GridSize;
      ye := (Y - Y0) div GridSize;
      if (X >= X0) and (Y >= Y0) and
      (xe < be.nTiles) and (ye < be.nTiles) then begin
        yz := be.bId [xe, ye];
        if (yz > 0) then
          say ('[' + IntToStr (xe) + '; ' + IntToStr (ye) + ']: Brick #'
                + IntToStr (yz) + ': ' + TypeName (yz))
        else
          say ('[' + IntToStr (xe) + '; ' + IntToStr (ye) + ']');
      end else
        say ('');
    end;
  end;
end;

procedure TForm1.SelectArea(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var i, j: Byte;
      SelRect: TRect;
begin
  ClipCursor (Nil);
  if (XX <> 99) and not (PlayMode) then begin
  if (xx > xe) then Swap (xx, xe);
  if (yy > ye) then Swap (yy, ye);
  For i := xx to xe do
  For j := yy to ye do begin
    SelRect.Left := X0 + i*GridSize + 1;
    SelRect.Right := X0 + (i+1)*GridSize - 1;
    SelRect.Top := Y0 + j*GridSize + 1;
    SelRect.Bottom := Y0 + (j+1)*GridSize - 1;

    if (sel [i, j] > 0) then begin
      sel [i, j] := 0;
      Board.Canvas.Pen.Color := clBtnShadow;
    end else begin
      sel [i, j] := 1;
      Board.Canvas.Pen.Color := clWhite;
    end;
    Board.Canvas.CopyMode := cmDstInvert;
    Board.Canvas.CopyRect (selRect, Canvas, SelRect);
    DrawTile (i, j);
  end;
  end;
  if (xx < 100) then
    XX := 99;
  YY := 0;
end;

procedure TForm1.RefreshClick(Sender: TObject);
begin
  Form1.RedrawBoard (Sender);
end;

function ArbitraryBrick (n: Byte): Boolean;
  var i, j, k: Byte;
      left, right, top, bottom: byte;
begin
  top := 99;
  left := 99;
  right := 0;
  bottom := 0;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (be.bID [i, j] = n) then begin
        if (j < top) then top := j;
        if (j > bottom) then bottom := j;
        if (i < left) then left := i;
        if (i > right) then right := i;
      end;
  k := 0;
  For i := left to right do
    For j := top to bottom do
      if (be.bID [i, j] <> n) then k := 1;
  ArbitraryBrick := (k > 0);
end;

procedure JoinKeyAndFrame;
  var i, j: byte;
begin
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do begin
      if (be.bID [i, j] = 1) and (be.bID [i+1, j] = 3) or
      (be.bID [i, j] = 3) and (be.bID [i+1, j] = 1) then begin
        Inc (be.bForm [i, j], 2);
        Inc (be.bForm [i+1, j], 8);
        drawTile (i, j);
        drawTile (i+1, j);
      end;
      if (be.bID [i, j] = 1) and (be.bID [i, j+1] = 3) or
      (be.bID [i, j] = 3) and (be.bID [i, j+1] = 1) then begin
        Inc (be.bForm [i, j], 4);
        Inc (be.bForm [i, j+1], 1);
        drawTile (i, j);
        drawTile (i, j+1);
      end;
    end;
end;

procedure ReformBricks (n, noRecursion: byte);
  var i, j, k: Byte;
begin
  k := 0;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (be.bID [i, j] = n) then begin
        be.bForm [i, j] := be.bForm [i, j] and 192;
        Inc (k);
        if (ArbitraryBrick (n)) or (n = 1) or (n = 3) then
          Inc (be.bForm [i, j], 16);
        if (j > 0) and (be.bID [i, j-1] = be.bID [i, j]) then
          Inc (be.bForm [i, j], 1);
        if (i < 24) and (be.bID [i+1, j] = be.bID [i, j]) then
          Inc (be.bForm [i, j], 2);
        if (j < 24) and (be.bID [i, j+1] = be.bID [i, j]) then
          Inc (be.bForm [i, j], 4);
        if (i > 0) and (be.bID [i-1, j] = be.bID [i, j]) then
          Inc (be.bForm [i, j], 8);
        if (j < be.nTiles) and (i < be.nTiles) then
          DrawTile (i, j)
      end;
  if (k = 0) and (n > 8) then be.bType [n] := 0;
  if (noRecursion = 0) and ((n = 3) or (n = 1)) then begin
    if (n = 3) then ReformBricks (1, 1);
    if (n = 1) then ReformBricks (3, 1);
    JoinKeyAndFrame;
  end;
end;

function CheckSel: Byte;
  var i, j, k: Byte;
begin
  k := 0;
  SelBricks := [];
  for i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        if ((be.bID [i, j] and 63) = 0) then
          k := k or 1
        else begin
          if ((be.bID [i, j] and 63) < 8) then begin
            case be.bID [i, j] of
              2:   k := k or 8;
              4:   k := k or 16;
              else k := k or 4;
            end;
          end else begin
            k := k or 2;
            SelBricks := SelBricks + [be.bID [i, j] and 63];
          end;
        end;
      end;
  Checksel := k;
end;

procedure MergeBricks (k, l: byte);
  var i, j: byte;
begin
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (be.bID [i, j] = k) then
        be.bID [i, j] := l;
  be.bType [k] := 0;
end;

procedure SortOutMaster (l: byte);
  var i: byte;
begin
  For i := 8 to 255 do
    if (be.bType [i] = brkMaster) and (i <> l) then begin
      be.bType [i] := brkNormal;
      ReformBricks (i, 0);
      Say ('Master changed from #' + IntToStr (i) + ' to #' + IntToStr (l));
    end;
end;

procedure ConvertSel (t: byte);
  var i, j, k, l: Byte;
begin
  l := CheckSel;
  if (t = brkBorder) then l := (l and 27);
  if (t = brkBlockade) then l := (l and 23);
  if (t = brkWater) then l := (l and 15);
  if (t = brkKeyhole) then l := (l and 3) or 1;

  if (l and 28 = 0) then begin
    if (l = 2) then begin
    (* Steintyp wechseln *)
      for i := 255 downto 8 do
        if (i in SelBricks) then begin
            be.bType [i] := t;
            if (t in [brkBorder, brkKeyhole, brkWater]) then begin
              if (t = brkBorder) then k := 1;
              if (t = brkKeyhole) then k := 3;
              if (t = brkWater) then k := 4;
              be.bType [k] := t;
              MergeBricks (i, k);
              ReformBricks (k, 0);
            end else
              ReformBricks (i, 0);
          if (t = brkMaster) then SortOutMaster (i);
          end;
      ResetSel;
      UndoInfo;
    end;
    if (l = 1) or (l = 3) then begin
    (* Steine setzen und verschmelzen *)
      k := 0;
      if (l = 1) then begin
        For i := 255 downto 8 do
          if (be.bType [i] = 0) then k := i;
      if (t = brkBorder) then k := 1;
      if (t = brkKeyhole) then k := 3;
      if (t = brkWater) then k := 4;
      end else begin
        For i := 255 downto 9 do
          if (i in SelBricks) then begin
            be.bType [i] := 0;
            k := i;
          end;
      end;
      be.bType [k] := t;
      For i := 0 to be.nTiles - 1 do
        For j := 0 to be.nTiles - 1 do
          if (sel [i, j] > 0) or (be.bID [i, j] in SelBricks) then begin
            be.bID [i, j] := k;
            sel [i, j] := 0;
          end;
      ReformBricks (k, 0);
      if (t = brkMaster) then SortOutMaster (k);
      UndoInfo;
    end;
    if (l = 0) then
      Say ('Nothing selected. (Click left or drag mouse to toggle selection.)');
  end else
    say ('Cannot change static bricks (Frame, Blockade, Water).');
end;

procedure TForm1.CreateBrickClick(Sender: TObject);
  var i, j, k: Byte;
begin
  ConvertSel (brkNormal);
end;

procedure TForm1.CreateMasterClick(Sender: TObject);
  var i, j: Byte;
begin
  ConvertSel (brkMaster);
end;

procedure TForm1.CreateBorderClick(Sender: TObject);
  var i, j: Byte;
begin
  ConvertSel (brkBorder);
end;

procedure TForm1.DeleteAreaClick(Sender: TObject);
  var i, j: Byte;
      Deleted: Set of Byte;
begin
  Deleted := [];
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        Deleted := Deleted + [be.bID [i, j]];
        be.bID [i, j] := 0;
        be.bForm [i, j] := 0;
      end;
  For i := 1 to 255 do
    if (i in Deleted) then ReformBricks (i, 0);
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        sel [i, j] := 0;
        Form1.Board.Canvas.Pen.Color := clBtnShadow;
        DrawTile (i, j);
      end;
end;

procedure TForm1.DeleteBrickClick(Sender: TObject);
  var i, j: Byte;
      Deleted: Set of Byte;
begin
  Deleted := [];
  UndoInfo;
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then
        Deleted := Deleted + [be.bID [i, j]];
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (be.bID [i, j] in Deleted) then begin
        sel [i, j] := 0;
        be.bID [i, j] := 0;
        be.bForm [i, j] := be.bForm [i, j] and 192;
        DrawTile (i, j);
      end;
  For i := 1 to 255 do
    if (i in Deleted) and (i > 8) then be.bType [i] := 0;
  if (Deleted <> []) then
    UndoInfo;
end;

procedure TForm1.BoardClick(Sender: TObject);
  var i, j, k: Byte;
begin
end;

procedure TForm1.CreateMagnetClick(Sender: TObject);
begin
  ConvertSel (brkMagnet);
end;

procedure TForm1.CreateMagicClick(Sender: TObject);
begin
  ConvertSel (brkMagic);
end;

procedure TForm1.CreateKeyholeClick(Sender: TObject);
begin
  ConvertSel (brkKeyhole);
end;

procedure TForm1.CreateElimClick(Sender: TObject);
begin
  ConvertSel (brkElim);
end;

procedure TForm1.CreateBlockadeClick(Sender: TObject);
  var i, j, l: byte;
begin
  ConvertSel (brkBlockade);
end;

procedure TForm1.CreateKeyClick(Sender: TObject);
begin
  ConvertSel (brkKey);
end;

procedure TForm1.CreateVSlideClick(Sender: TObject);
begin
  ConvertSel (brkVSlide);
end;

procedure TForm1.createHSlideClick(Sender: TObject);
begin
  ConvertSel (brkHSlide);
end;

procedure TForm1.CreateBarrierClick(Sender: TObject);
begin
  ConvertSel (brkBarrier);
end;

procedure TForm1.CreateAntiClick(Sender: TObject);
begin
  ConvertSel (brkAnti);
end;

procedure TForm1.CreateWaterClick(Sender: TObject);
begin
  ConvertSel (brkWater);
end;

procedure TForm1.createMasterMagnetClick(Sender: TObject);
begin
  ConvertSel (brkMasterMagnet);
end;

procedure SelFloor (t: Byte);
  var i, j: Byte;
begin
  For i := 0 to be.nTiles - 1 do
    For j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        sel [i, j] := 0;
        be.bForm [i, j] := be.bForm [i, j] and 63 + t;
        DrawTile (i, j);
      end;              
  UndoInfo;
end;

procedure TForm1.CreateTargetClick(Sender: TObject);
begin
  SelFloor (flrTarget);
end;

procedure TForm1.CreateTrapClick(Sender: TObject);
begin
  SelFloor (flrTrap);
end;

procedure TForm1.CreateHoleClick(Sender: TObject);
begin
  SelFloor (flrHole);
end;

procedure doSaveBoard (fn: String);
  var i, j: Byte;
      f: File of Byte;
      title: String;
begin
  Assign (f, fn);
  Rewrite (f);
  i := 1;
  Write (f, i);

  Title := Form1.LevelName.Caption;
  for i := 0 to length (Title) do begin
    j := ord (Title [i]);
    Write (f, j);
  end;

  j := 0;
  For i := 1 to 255 do
    if (be.bType [i] > 0) then
      j := i;
  Write (f, j);
  for i := 1 to j do
    Write (f, be.bType [i]);
  Write (f, be.nTiles);
  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      Write (f, be.bID [i, j], be.bForm [i, j]);
  Close (f);
  Form1.Caption := ProgTitle + ' - '
                + ExtractFilename (Form1.OpenDialog.Filename);
  Dirty := False;
end;

procedure doLoadBoard (fn: String);
  var i, j: Byte;
      f: File of Byte;
      title: String;
      Sender: TObject;
begin
  Assign (f, fn);
  Reset (f);
  Read (f, i);

  Read (f, j);
  Title [0] := chr (j);
  for i := 1 to j do begin
    Read (f, j);
    Title [i] := chr (j);
  end;
  Form1.LevelName.Caption := Title;

  Read (f, j);
  for i := 1 to j do
    Read (f, be.bType [i]);
  For i := j+1 to 255 do
    be.bType [i] := 0;
  for i := 0 to 24 do
    for j := 0 to 24 do begin
      be.bForm [i, j] := 0;
      be.bID [i, j] := 0;
    end;
  Read (f, be.nTiles);
  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      Read (f, be.bID [i, j], be.bForm [i, j]);
  Close (f);
  Form1.RedrawBoard (Sender);
end;

procedure TForm1.SaveasClick(Sender: TObject);
begin
  with SaveDialog do
    if (execute) then begin
      doSaveBoard (Filename);
      Form1.Caption := ProgTitle + ' - ' + ExtractFilename (Filename);
      OpenDialog.Filename := Filename;
    end;
end;

procedure TForm1.OpenBoardClick(Sender: TObject);
begin
  if CheckDirty then
    with OpenDialog do
      if (execute) then begin
        doLoadBoard (Filename);
        Form1.Caption := ProgTitle + ' - ' + ExtractFilename (Filename);
        ClearDirty;
      end;
end;

procedure TForm1.SaveBoardClick(Sender: TObject);
begin
  if (OpenDialog.Filename <> '') then
    doSaveBoard (OpenDialog.Filename)
  else
    SaveasClick (Sender);
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
  AboutBox.Show;
end;

procedure TForm1.HelpTopicsClick(Sender: TObject);
begin
  Application.HelpFile := 'bricksed.hlp';
  if not (Application.HelpJump ('contents')) then
    ShowMessage ('Sorry, but the help section is not available.');
end;

procedure TForm1.NewBoardClick(Sender: TObject);
begin
  if CheckDirty then
    Form1.BricksInit (Sender);
end;

procedure TForm1.ExitEditorClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.CloseAndCheck(Sender: TObject; var Action: TCloseAction);
begin
  if not(CheckDirty) then
    Action := caNone;
end;

procedure TForm1.clearFloorClick(Sender: TObject);
  var i, j, k: byte;
begin
  k := 0;
  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      if (sel [i, j] > 0) then begin
        if (be.bForm [i, j] and 192 > 0) then begin
          be.bForm [i, j] := be.bForm [i, j] and 63;
          Inc (k);
        end;
        sel [i, j] := 0;
        DrawTile (i, j);
      end;
  If (k > 0) then begin
    Say (IntToStr (k) + ' floor items removed.');
    UndoInfo;
  end else
    say ('No floor items selected.');
end;

procedure TForm1.PlayLevelClick(Sender: TObject);
begin
  bp := be;
  Spiel.Visible := True;
  Steuerung.Visible := False;
  PlayMode := true;
  Moves := 0;   
  bRamMove := 0;
  PrevBrick := 0;
  (* Form1.RedrawBoard (Sender); *)
  NameOfLevel.Caption := LevelName.Caption;
  Say ('Entering test play mode...');
  New (MoveRec);
  Playmode1.Checked := True;
end;

procedure TForm1.ResetBoardClick(Sender: TObject);
begin
  bp := be;
  Moves := 0;
  bRamMove := 0;
  PrevBrick := 0;
  Form1.RedrawBoard (Sender);
  Say ('Board reset to initial position.');
end;

procedure TForm1.UndoMoveClick(Sender: TObject);
begin
  showMessage ('The undo option does not work yet. Sorry for this.');
end;

procedure TForm1.SetBoardSizeClick(Sender: TObject);
  var s: Integer;
begin
  SetSizeDlg.Show;
end;

procedure TForm1.SelectAllClick(Sender: TObject);
  var i, j: Byte;
begin
  for i := 0 to be.nTiles - 1 do
    for j := 0 to be.nTiles - 1 do
      if (sel [i, j] = 0) then begin
        sel [i, j] := 1;
        drawTile (i, j);
      end;
end;

procedure TForm1.CheckBoardClick(Sender: TObject);
begin
  if not (PlayMode) then
    CheckDlg.Show;
end;

procedure TForm1.UndoEditClick(Sender: TObject);
  var i, j: byte;
begin
  If not(PlayMode) then begin
  Dec (MovesSaved);
  Inc (MovesUndone);
  Dec (MovePointer);
  if (MovePointer = 0) then
    MovePointer := nUndo;
  be := bu [MovePointer]^;
  RedrawBoard (Sender);
  if (MovesSaved = 0) then
    Form1.UndoEdit.Enabled := False;
  Form1.RedoEdit.Enabled := True;
  Say (IntToStr (MovesSaved));
  end;
end;

procedure TForm1.RedoEditClick(Sender: TObject);
begin
  If not(PlayMode) then begin
  Inc (MovesSaved);
  Dec (MovesUndone);
  Inc (MovePointer);
  if (MovePointer > nUndo) then
    MovePointer := 0;
  be := bu [MovePointer]^;
  RedrawBoard (Sender);
  if (MovesUndone = 0) then
    Form1.RedoEdit.Enabled := False;
  Form1.UndoEdit.Enabled := True;
  end;
end;

procedure TForm1.StopGameClick(Sender: TObject);
begin
  bp := be;
  PlayMode := false;
  Spiel.Visible := False;
  Steuerung.Visible := True;
  Moves := 0;
  (* Form1.RedrawBoard (Sender); *)
  Say ('Entering editing mode...');
  Playmode1.Checked := False;
end;

procedure TForm1.DeleteAreaTopicClick(Sender: TObject);
begin
  Form1.DeleteAreaClick(Sender);
end;

procedure TForm1.DeleteBricksTopicClick(Sender: TObject);
begin
  Form1.DeleteBrickClick(Sender);
end;

procedure TForm1.ClearFloorTopicClick(Sender: TObject);
begin
  Form1.ClearFloorClick(Sender);
end;

procedure TForm1.NormalBrick1Click(Sender: TObject);
begin
  ConvertSel (brkNormal);
end;

procedure TForm1.MasterBrick1Click(Sender: TObject);
begin
  ConvertSel (brkMaster);
end;

procedure TForm1.Hole1Click(Sender: TObject);
begin
  SelFloor (flrHole);
end;

procedure TForm1.TargetDestination1Click(Sender: TObject);
begin
  SelFloor (flrTarget);
end;

procedure TForm1.Trap1Click(Sender: TObject);
begin
  SelFloor (flrTrap);
end;

procedure TForm1.Frame1Click(Sender: TObject);
begin
  ConvertSel (brkBorder);
end;

procedure TForm1.Barrier1Click(Sender: TObject);
begin
  ConvertSel (brkBarrier);
end;

procedure TForm1.LevelNameClick(Sender: TObject);
begin
  TitleDlg.Show;
end;

procedure TForm1.Magnet1Click(Sender: TObject);
begin
  ConvertSel (brkMagnet);
end;

procedure TForm1.AntiMagnet1Click(Sender: TObject);
begin
  ConvertSel (brkAnti);
end;

procedure TForm1.MasterMagnet1Click(Sender: TObject);
begin
  ConvertSel (brkMasterMagnet);
end;

procedure TForm1.N9Click(Sender: TObject);
begin
  ConvertSel (brkKey);
end;

procedure TForm1.Keyhole1Click(Sender: TObject);
begin
  ConvertSel (brkKeyhole);
end;

procedure TForm1.BlockadeBrick1Click(Sender: TObject);
begin
  ConvertSel (brkBlockade);
end;

procedure TForm1.MagicBrick1Click(Sender: TObject);
begin
  ConvertSel (brkMagic);
end;

procedure TForm1.HorizontalSlider1Click(Sender: TObject);
begin
  ConvertSel (brkHSlide);
end;

procedure TForm1.VerticalSlider1Click(Sender: TObject);
begin
  ConvertSel (brkVSlide);
end;

procedure TForm1.Eliminator1Click(Sender: TObject);
begin
  ConvertSel (brkElim);
end;

procedure TForm1.WaterField1Click(Sender: TObject);
begin
  ConvertSel (brkWater);
end;

procedure TForm1.LevelName1Click(Sender: TObject);
begin
  if not (Playmode) then
    TitleDlg.Show;
end;

procedure TForm1.IncreaseBoardSize1Click(Sender: TObject);
begin
  if not (Playmode) then
    Form1.IncGridClick (Sender);
end;

procedure TForm1.DecreaseBoardSize1Click(Sender: TObject);
begin
  if not (Playmode) then
    Form1.DecGridClick (Sender);
end;

procedure TForm1.AutomaticClipping1Click(Sender: TObject);
begin
  if not (Playmode) then
    Form1.AutoSizeClick (Sender);
end;

procedure TForm1.AliBabasFakeFrame1Click(Sender: TObject);
begin
  ConvertSel (brkFake);
end;

procedure CutAndCopy;
  var i, j: Byte;
      xmin, ymin, xmax, ymax: Byte;
begin
  xmin := 99;
  ymin := 99;
  xmax := 0;
  ymax := 0;
  For i := 0 to be.nTiles -1 do
    For j := 0 to be.nTiles -1 do
      if (sel [i, j] > 0) then begin
        if (i < xMin) then xMin := i;
        if (j < yMin) then yMin := j;
        if (i > xMax) then xMax := i;
        if (j > yMax) then yMax := j;
      end;
  if (xmin <> 99) then begin
    if (xmax - xmin > ymax - ymin) then
      bClip.nTiles := xmax - xmin + 1
    else
      bClip.nTiles := ymax - ymin + 1;
    For i := xmin to xmax do
      For j := ymin to ymax do
        if (sel [i, j] > 0) then begin
          bClip.bID [i-xmin, j-ymin] := be.bID [i, j];
          bClip.bForm [i-xmin, j-ymin] := be.bForm [i, j];
        end else begin
          bClip.bID [i-xmin, j-ymin] := 0;
          bClip.bForm [i-xmin, j-ymin] := 0;
        end;
  end;
end;

procedure TForm1.xxCopyClick(Sender: TObject);
begin        
  CutAndCopy;
end;

procedure TForm1.xxCutClick(Sender: TObject);
begin
  CutAndCopy;
  Form1.DeleteAreaClick (Sender);
end;

procedure TForm1.xxPasteClick(Sender: TObject);
  var i, j: Byte;
      xmin, ymin: Byte;
begin
  xmin := 99;
  ymin := 99;
  For i := 0 to be.nTiles -1 do
    For j := 0 to be.nTiles -1 do
      if (sel [i, j] > 0) then begin
        if (i < xMin) then xMin := i;
        if (j < yMin) then yMin := j;
      end;
  if (xmin <> 99) then begin
  end;
end;

procedure TForm1.PlayMode1Click(Sender: TObject);
begin
  if (PlayMode) then
    Form1.StopGameClick (Sender)
  else
    Form1.PlayLevelClick (Sender);
end;

procedure TForm1.StepBackward1Click(Sender: TObject);
begin
  bp := bUndo;
  RedrawBoard (Sender);
end;

procedure TForm1.StoreBoardClick(Sender: TObject);
begin
  if (PlayMode) then begin
    bRAM := bp;
    bRamMove := Moves;
    Say ('Board stored to memory.');
  end;
end;

procedure TForm1.LoadBoardfromRAM1Click(Sender: TObject);
begin
  if (PlayMode) and (bRamMove > 0) then begin
    bp := bRAM;
    Moves := bRamMove;
    Say ('Board successfully retrieved.');
    RedrawBoard (Sender);
  end;
end;

end.
